#Tile info patching script for Keen 1
%ext ck1

%version 1.31
%patchfile 0x130F8 tilesb.tli

###VORTICON###
#Dead vorticon turns into live Yorp
%patch $1D8D $90 $90 $90 $90 $90 $90 $90 $90 $90 #Don't play death sound
%patch $1DAF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 #Don't flash border
%patch $1DAD $4F $19 #Make dead Vort behave like Yorp
%patch $1DA8 $68 $1A #Make it spawn a dead Yorp when shot
%patch $1DA3 $30 $00 #Yorp start sprite
%patch $1D98 $00 $05 $00 #Make it push Keen like a Yorp
#Vorticons don't jump:
%patch $1C49 $01 $00 #This cannot be 0, so make it small instead
%patch $17E0 $03 $00 #Use Garg chain behaviour
%patch $1819 $03 $00 # Strength of vorticon commander-1
###############

###GARG###
#If the Garg is shorter or Keen is taller: 
%patch $1B8B $00 
%patch $1B89 $EA
%patch $1B9F  180 #Left AND right speed when charging toward Keen
%patch $1B4C -128 #Height Garg jumps when chasing Keen over a cliff
##########

###ROBOT###
#%patch $176D $6E $1D #Shot robot creates life yorp
#Make Tankbot stompable:
#SIDE EFFECT: Yorp not stompable
#Switch Yorp\tbot interaction:
%patch $188B $06 $00 #Yorp not stompable
%patch $171E $02 $00 #Tank stompable
#Make stomped sprite become a tbot not Yorp when it recovers:
%patch $1A58 $C1 $1F #After stunned, be a shooting Tankbot
#Make the Tank bot shot not hit $02 Tbot:
%patch $4A0D $02 #Don't hit this
###########

###ICE CANNON###
%patch $20D6 $03 $00 #Make big ice blocks kill Keen.
%patch $2058 $08     #Ice cannon shoot rate
%patch $20F3 $51 $21 #Icecubes impermanent
%patch $209B $26 #Shot sound
################

###YORP###
%patch $1964 $30 $01 #Yorp jump height
%patch $188B $03 $00 #Yorp kills Keen
%patch $158D4 "EGASPRIH"
##########

###FALLING BLOCK####
#Location of block left end from chain
%patch $238D $FF $FF
#Location of middle of block END from chain, number used =
#$FF $FF MINUS [blocks wanted - 5] here FD = FF - [8 - 5] [$04 = no blocks]
%patch $23F4 $04 $00
#Location of block right end, from chain, use $FF $FD for -ve values
%patch $2476 $00 $00
#Change the tiles the block leaves behind
%patch $23AB $8F $00 #left
%patch $2414 $8F $00 #middle
%patch $2494 $8F $00 #right
####################

#Levels start with lights off:
%patch $4C92 $E8 $B4 $1F $90 $90 $90
%patch $4CA1 $E8 $0E $E9

#Pogo gives extra Keen!
%patch $44AB  $FF $06 $C6 $AA $90 $90

#Keen always has a pogo
%patch $900E  $01 $00 

# Set the raygun to give 4 shots
%patch $44A4  $04

#The four parts must be got to pass a part of the map
#The blocks will be sprites 25*, 27*, 29* and 31*
#SIDE EFFECT: Levels 21-24 can be played as normal levels

#Make space in the level done array for the item-blocks
%patch $7D3A  $90 $90 $80 $BF $A6 $AA $00      #Create space
%patch $7FCA  $90 $90 $80 $BF $A5 $AA $00
#%patch $9065  $90 $90 $C6 $87 $A6 $AA $00 $90  #Empty space at game start
#%patch $9070  $83 $7E $F8 $20
%patch $8013  $90 $90 $C6 $87 $A5 $AA $01 $90  #Change how levels are marked as done
%patch $7E48  $83 $7E $FC $20 

#Now change the parts tiles to remove map blocks:
%patch $4448 $BE #Joystick (25*)
%patch $4454 $C0 #Battery (27*)
%patch $4460 $C2 #Vacum (29*)
%patch $446C $C4 #Everclear (31*)

#Status window tiles still light up when parts got
%patch $101D $BE #Joystick
%patch $1049 $C0 #Battery
%patch $1075 $C2 #Vacum
%patch $10A1 $C4 #Whiskey

#Change what we need for ending so it still works
#And make it so level 16 needs to be done too
%patch $8022 $BE #Joystick
%patch $8029 $C0 #Battery
%patch $8030 $C2 #Vacum
%patch $8037 $B4 #Level 16 completed

#Change high scores so parts still appear
%patch $8C14 $BE #Joystick
%patch $8C38 $C0 #Battery
%patch $8C5E $C2 #Vacum
%patch $8C85 $C4 #Whiskey

#Change BwB missing parts window so still works
%patch $AE72 $BE #Joystick
%patch $AE97 $C0 #Battery
%patch $AEBC $C2 #Vacum
%patch $AEE1 $C4 #Whiskey

#Exit tiles don't change when Keen exits
%patch $417E $90 #Top blank tile doesn't appear
%patch $41A7 $90 #Bottom blank tile doesn't appear

# Keen does not lose ship parts on dying in their levels.
%patch $4F82 $90 $90 $90 $90 $90 $90 #Joystick
%patch $4F8A $90 $90 $90 $90 $90 $90 #Battery
%patch $4F92 $90 $90 $90 $90 $90 $90 #Vacum
%patch $4F9A $90 $90 $90 $90 $90 $90 #everclear

#Status Screen
%patch 0x014E83 "CRYSTALS  "
%patch 0x014EAC "KEYS    "
%patch 0x014E9B "PISTOL"

#Menu
%patch 0x015F12 "About Me   "
%patch 0x015F32 "Episodes     "
%patch 0x015F41 "   Monsters "

%level.hint 2
The Fengfong says:
"So you managed to 
find the secret 
stage. Now can you
finish it?"

%level.hint 6
The Fengfong says:
"The solution is
to find the right
switch. Look
carefully."

%level.hint 9
The Fengfong says:
"Remember if a
heart blocks your
way, try to cut
it loose."

%level.hint 15
The Fengfong says:
"You must search
in the south to get
the gem for the
next gate."

#About ID...
%patch 0x015F80 "This is a Keenday release for     "
%patch 0x015FA8 "3/14 2009. It was planned as a   "
%patch 0x015FD0 "Minimod but somehow ended up  "
%patch 0x015FF8 "as a full mod. Don't"
%patch 0x016020 "forget to play the other parts  "
%patch 0x016048 "of the 4 part trilogy Onward:Silcar"
%patch 0x016070 "Download at bipship.com   "
%patch 0x016098 "or at my files account "
%patch 0x0160C0 "www.mediafire.com/tulip.     "
%patch 0x0160E8 "Thanks for the help of the       "
%patch 0x016110 "keenmodding community.   "

#Map top-left corner coords (multiplied by $1000) 
%patch $81D7 $00     #x position (x10)
%patch $81DD $03     #x position (Total 0-3 = 3 tiles)
%patch $81E2 $70     #Y position (x10)
%patch $81E8 $03     #Y position (Total 2-3 = 23 tiles)

#Finale
%patch 0x015C24 "Just this moment a strange ship    "
%patch 0x015C49 "left the Creature. Keen rushed to"
%patch 0x015C6C "the B-W-B to follow this esteemed  "
%patch 0x015C91 "bounty hunter for Keens head.  "

# First dialogue box at home
%patch 0x015CBD "Keen followed it all  "
%patch 0x015CD5 "the way to Strgwz "
%patch 0x015CE9 "just to miss it. "

%patch 0x015CFB "A Hyperspace-gate  "
%patch 0x015D10 "just closed before "
%patch 0x015D25 "he came.  "

%patch 0x015D30 "Keen had to go down  "
#Text jump
%patch 0x015D47 "again on Strgwz...   "
%patch 0x015D5E "He had to go to the"
%patch 0x015D73 "dark side. "

%patch 0x015D80 "Keen thought who"
%patch 0x015D92 "was that?"

%patch 0x015D9C "The Hyperspace Gate   "
%patch 0x015DB4 "had to be powered by"
%patch 0x015DCA "a planetary Generator. "

%patch 0x015DE2 "Will he get coords?"

%patch 0x015DF6 "He had to!      "

%patch 0x015E07 "Keen was not so sure "
%patch 0x015E1E "this was Morts doing   "
%patch 0x015E37 "though he was known"
%patch 0x015E4C "for always escaping  "
%patch 0x015E63 "Keen, yet!    "

%end
